::Demucs+CC_Stereo_to_5.1 by zcftr29 (With A LOT of help from zeerround)
::PrepForDemucs Script - Version 0.2b

@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

set script_version=0.2b
TITLE Demucs+CCG_Stereo_to_5.1: PrepForDemucs Script - Version %script_version%
MODE CON Lines=40

REM ----------Set program paths

SET parent=%~dp0

SET PATH=!PATH!;%parent%bin;%parent%bin\SoX;%parent%bin\Tag;%parent%bin\dialogboxes;

REM ----------Find Desktop Path

ECHO set WshShell = WScript.CreateObject("WScript.Shell")>findDesktop.vbs
ECHO strDesktop = WshShell.SpecialFolders("Desktop")>>findDesktop.vbs
ECHO wscript.ECHO(strDesktop)>>findDesktop.vbs

FOR /F "usebackq delims=" %%i in (`cscript findDesktop.vbs`) DO SET DESTINATION=%%i

del findDesktop.vbs

REM ----------Set File Parameters

Set NoSourceFiles=0

FOR  %%x IN (%*) DO (

	Set /A "NoSourceFiles=NoSourceFiles +1"
	Set FileNumber=!NoSourceFiles!

	sox --i %%x>>soxi.txt

	FOR /F "tokens=1,2,3,4,5,6,7,8 delims=: " %%G IN (soxi.txt) DO (
		IF %%G%%H==SampleRate SET FileNo_!FileNumber!_SAMPLERATE=%%I
		IF %%G==Duration SET FileNo_!FileNumber!_DURATION=%%L
		)

	del soxi.txt

	SET FileNo_!FileNumber!_PATH=%%~dpx
	SET FileNo_!FileNumber!_FILENAME=%%~nx
	SET FileNo_!FileNumber!_EXT=%%~xx

	)

REM ----------Display File Names

SET FileNumber=1

SET Message=Demucs+CCG_Stereo_to_5.1: PrepForDemucs Script - Version %script_version%\015\015Files to process:\015\015
:DisplayNextFile
SET Message=!Message!!FileNo_%FileNumber%_FILENAME!\015
Set /A "FileNumber=!FileNumber! + 1"
IF %FileNumber% LEQ %NoSourceFiles% goto DisplayNextFile
Echo:

REM ----------Read ini file

Echo Reading ini file... Please wait

:: GainSettings
For /F "tokens=*" %%A IN ('call "%~dp0\bin\ini.bat" /s GainSettings /i pregain "%~dp0\bin\Demucs+CC_Stereo_to_5.1.ini"') DO SET PreGain=%%A

REM ----------Set Conversion Destination

CLS
:: AgreeDefaults
SET Message=!Message!\015\015By default, this script will save all files to a folder called 'Demucs+CC_Stereo_to_5.1' on your desktop, i.e:\015\015"%DESTINATION%\Demucs+CC_Stereo_to_5.1"\015\015To Accept these settings, click yes - otherwise click no to choose another output path.\015\015(Yes will be selected automatically in 30 seconds)

rem For /F "tokens=*" %%A IN ('RichTextMessageBox "%Message%" "Accept Output Destination" /Font:"Segoe UI" /FS:10 /B1:"Yes" /B2:"No" /DB:1 /WW:900 /T:30') DO SET AcceptDest=%%A
For /F "tokens=*" %%A IN ('MessageBox.exe "%Message%" "Accept Output Destination" /O:N /B:Y /I:Q /T:30') DO SET AcceptDest=%%A

IF %AcceptDest%==yes SET DESTINATION=!DESTINATION!\Demucs+CC_Stereo_to_5.1& goto DestAggreed

SET Message="Please select your prefered destination"

:ChangeDest
For /F "tokens=*" %%A IN ('OpenFolderBox "%DESTINATION%" %Message% /MD ^|^| ECHO Error^& IF ERRORLEVEL 2 ECHO Cancel') DO SET FolderBoxOutput=%%A

IF "%FolderBoxOutput%"=="Cancel" SET Message="You clicked Cancel, Please select your prefered destination"& goto ChangeDest
IF "%FolderBoxOutput%"=="Error" SET Message="Something went wrong, please select your prefered destination"& goto ChangeDest

SET DESTINATION=%FolderBoxOutput%

:DestAggreed

REM ----------Create Folders

IF NOT EXIST "%DESTINATION%" md "%DESTINATION%"
IF NOT EXIST "%DESTINATION%\ForDemucs" md "%DESTINATION%\ForDemucs"
IF NOT EXIST "%DESTINATION%\Demucs" md "%DESTINATION%\Demucs"
IF NOT EXIST "%DESTINATION%\Source" md "%DESTINATION%\Source"
IF NOT EXIST "%DESTINATION%\Source_%PreGain%dB" md "%DESTINATION%\Source_%PreGain%dB"
IF NOT EXIST "%DESTINATION%\bin" md "%DESTINATION%\bin"

REM ----------FileParameters.txt

SET NoSourceFiles>ParamTemp.txt
SET FileNo_>>ParamTemp.txt
FOR /F "tokens=* delims=" %%G IN (ParamTemp.txt) DO ECHO SET %%G>>"%DESTINATION%\bin\FileParameters.txt"
del ParamTemp.txt

REM ----------Process Source Files

:ProcessSourceFiles

Set FileNumber=1

:ProcessNextFile

REM ----------SET DOWNRATECOMMAND

IF !FileNo_%FileNumber%_SAMPLERATE!==44100 SET DOWNRATECOMMAND= 
IF !FileNo_%FileNumber%_SAMPLERATE!==88200 SET DOWNRATECOMMAND= rate -v -L -s 44100
IF !FileNo_%FileNumber%_SAMPLERATE!==176400 SET DOWNRATECOMMAND= rate -v -L -s 44100 
IF !FileNo_%FileNumber%_SAMPLERATE!==48000 SET DOWNRATECOMMAND= speed 0.91875 rate -v -L -s 44100
IF !FileNo_%FileNumber%_SAMPLERATE!==96000 SET DOWNRATECOMMAND= speed 0.91875 rate -v -L -s 44100 
IF !FileNo_%FileNumber%_SAMPLERATE!==192000 SET DOWNRATECOMMAND= speed 0.91875 rate -v -L -s 44100

REM ----------Copy source file to destination

IF NOT EXIST "%DESTINATION%\Source\!FileNo_%FileNumber%_FILENAME!!FileNo_%FileNumber%_EXT!" Copy "!FileNo_%FileNumber%_PATH!!FileNo_%FileNumber%_FILENAME!!FileNo_%FileNumber%_EXT!" "%DESTINATION%\Source"

REM ----------Reduce source file by PreGain

IF NOT EXIST "%DESTINATION%\Source_%PreGain%dB\FileNo_%FileNumber%_%PreGain%dB.flac" Sox -S "!FileNo_%FileNumber%_PATH!!FileNo_%FileNumber%_FILENAME!!FileNo_%FileNumber%_EXT!" -b 24 "%DESTINATION%\Source_%PreGain%dB\FileNo_%FileNumber%_%PreGain%dB.flac" GAIN %PreGain%

REM ----------Prepare 'ForDemucs' file

IF NOT EXIST "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!*.flac" Sox -S "%DESTINATION%\Source_%PreGain%dB\FileNo_%FileNumber%_%PreGain%dB.flac" -b 24 "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!.flac"!DOWNRATECOMMAND!

REM ----------Check 'ForDemucs' filesize and split into max 100MB chunks if necessary

FOR /F "tokens=1,2,3,4,5 delims=:^(^) " %%G IN ('dir "%DESTINATION%\ForDemucs\*!FileNo_%FileNumber%_FILENAME!*" /-C /W') DO (
	IF %%H==File SET FILESIZE=%%J
	)

sox --i "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!.flac">>soxi.txt

FOR /F "tokens=1,2,3,4,5,6,7,8 delims=: " %%G IN (soxi.txt) DO (
	IF %%G==Duration SET DURATION=%%L
	)
del soxi.txt


SET PART_No=1
SET NoCHUNKS=0

IF %FILESIZE% LSS 100000000 goto NoSplit

:SplitPart1
SET /A "NoCHUNKS=FILESIZE / 100000000"
SET NoCHUNKS=!NoCHUNKS:~0,1!
SET /A "NoCHUNKS=!NoCHUNKS! + 1"
SET /A "SPLIT_LENGTH=DURATION / NoCHUNKS"
SET PART_START=0
SET /A "PART_LENGTH=SPLIT_LENGTH+44100"
Sox -S "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!.flac" "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!_SplitPart!PART_No!of!NoCHUNKS!.flac" trim %PART_START%s %PART_LENGTH%s
SET /A "PART_LENGTH=!PART_LENGTH!+44100"
SET /A "PART_No=!PART_No! + 1"

:SplitNextPart
SET /A "PART_START=!PART_START! + SPLIT_LENGTH"
IF %PART_No% LEQ %NoCHUNKS% Sox -S "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!.flac" "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!_SplitPart!PART_No!of!NoCHUNKS!.flac" trim %PART_START%s %PART_LENGTH%s
IF %PART_No% LSS %NoCHUNKS% goto SplitNextPart

Del "%DESTINATION%\ForDemucs\!FileNo_%FileNumber%_FILENAME!_!FileNo_%FileNumber%_SAMPLERATE!.flac"

:NoSplit

Set /A "FileNumber=!FileNumber! + 1"

IF %FileNumber% LEQ %NoSourceFiles% goto ProcessNextFile

REM ----------Copy bin folder to destination

XCopy "%parent%bin" "%DESTINATION%\bin" /S /Y

REM ----------Move Flac2DemucsStems.bat and PostDemucs.bat

move "%DESTINATION%\bin\PostDemucs.bat" "%DESTINATION%\"
move "%DESTINATION%\bin\Flac2DemucsStems.bat" "%DESTINATION%\"

REM ----------Open https://mvsep.com/

Start https://github.com/facebookresearch/demucs
Start https://mvsep.com/

CLS

REM ----------Write and Display Demucs Separation Instructions

ECHO All Files should now be in your destination folder:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO "%DESTINATION%">>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO The Websites "https://mvsep.com/" and "https://github.com/facebookresearch/demucs" should now be open in your browser.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO mvsep.com is much faster than running Demucs on your local machine unless you have a very fast PC with a good GPU.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO If you would prefer to run Demucs locally, follow the installation instructions on the Demucs Website.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO Once Installed (if not already), double click on the "Flac2DemucsStems.bat" bat file to do the conversion.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO To use "https://mvsep.com/", upload all the files in the 'ForDemucs' folder to mvsep.com (one at a time) and convert>>"%DESTINATION%\DemucsInstructions.txt"
ECHO with the following settings for the best quality:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO 	Separation type: Demucs3 Model B (vocals, drums, bass, other)>>"%DESTINATION%\DemucsInstructions.txt"
ECHO 	Output encoding: flac (lossless)>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO Once Separation is complete, download the 'Drums', 'Bass', 'Other' and 'Vocal' Files to the 'Demucs' subfolder within>>"%DESTINATION%\DemucsInstructions.txt"
ECHO the 'Demucs+CC_Stereo_to_5.1' folder in your chosen destination.  You do NOT need to download the 'Instrumental' File>>"%DESTINATION%\DemucsInstructions.txt"
ECHO or the 'Original' File.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO When saving, keep the default file names, as the 'PostDemucs' script will be looking for files with a particular>>"%DESTINATION%\DemucsInstructions.txt"
ECHO naming pattern.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO Optionally, once the Demucs Separation is complete, re-upload the 'Other' file from the 'Demucs' folder and re-convert>>"%DESTINATION%\DemucsInstructions.txt"
ECHO with the following settings in order to extract a 'Piano' Stem:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO 	Separation type: Ultimate Vocal Remover HQ (vocals, music)>>"%DESTINATION%\DemucsInstructions.txt"
ECHO 	Model type: WIP-Piano-4band-129605kb (Piano model)>>"%DESTINATION%\DemucsInstructions.txt"
ECHO 	Aggressiveness: 0.3>>"%DESTINATION%\DemucsInstructions.txt"
ECHO 	Output encoding: flac (lossless)>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO This time, save the 'Piano' File ONLY to the Demucs folder.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO Be warned... the quality of the UVR piano separation is not as good as the Demucs instruments.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO Listen to it before you decide to use in your upmix.>>"%DESTINATION%\DemucsInstructions.txt"
ECHO:>>"%DESTINATION%\DemucsInstructions.txt"
ECHO Once you have completed the Demucs / Ultimate Vocal Remover Separation,>>"%DESTINATION%\DemucsInstructions.txt"
ECHO double click on the 'PostDemucs.bat' batch file which should be in your destination folder.>>"%DESTINATION%\DemucsInstructions.txt"

SET Message=All Files should now be in your destination folder:\015\015\042%DESTINATION%\042\015\015The Websites \042https://mvsep.com/\042 and \042https://github.com/facebookresearch/demucs\042 should now be open in your browser.\015\015mvsep.com is much faster than running Demucs on your local machine unless you have a very fast PC with a good GPU. If you would prefer to run Demucs locally, follow the installation instructions on the Demucs Website. Once Installed (if not already), double click on the \042Flac2DemucsStems.bat\042 bat file to do the conversion.\015\015To use \042https://mvsep.com/\042, upload all the files in the 'ForDemucs' folder to mvsep.com (one at a time) and convert with the following settings for the best quality:\015\015Separation type: Demucs3 Model B (vocals, drums, bass, other)\015Output encoding: flac (lossless)\015\015Once Separation is complete, download the 'Drums', 'Bass', 'Other' and 'Vocal' Files to the 'Demucs' subfolder within your chosen destination.  You do NOT need to download the 'Instrumental' File or the 'Original' File.\015\015When saving, keep the default file names, as the 'PostDemucs' script will be looking for files with a particular naming pattern.\015\015Optionally, once the Demucs Separation is complete, re-upload the 'Other' file from the 'Demucs' folder and re-convert with the following settings in order to extract a 'Piano' Stem:\015\015Separation type: Ultimate Vocal Remover HQ (vocals, music)\015Model type: WIP-Piano-4band-129605kb (Piano model)\015Aggressiveness: 0.3\015Output encoding: flac (lossless)\015\015This time, save the 'Piano' File ONLY to the Demucs folder.\015Be warned... the quality of the UVR piano separation is not as good as the Demucs instruments. Listen to it before you decide to use in your upmix.\015\015Close this window, by clicking 'OK' and once you have completed the Demucs / Ultimate Vocal Remover Separation, double click on the 'PostDemucs.bat' batch file which should be in your destination folder.

MessageBox.exe "%Message%" "Preparation Complete" /O:N /B:O /I:I